QGIS Application - Bug report #7944
addFeatures in provider does not return properly the feature ID
2013-05-30 04:44 AM - Denis Rouzaud

Status: Closed

Priority: Severe/Regression

Assignee: Matthias Kuhn

Category: Vectors

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16811
Description

In python, when doing:
ans, fout = provider.addFeatures( [fin] )

The feature fin is properly added, but doing fout[0].id() returns 0.

In postgres, the feature is created and has a different ID.

It is a regression because it used to work.

The same problem existed before but was solved in commit:7028827

History

#1 - 2013-06-04 01:52 PM - Matthias Kuhn

I had a look at this today. It's quite strange, because the result is assigned in the provider and the proper id is still available from sip.

It looks as if a copy of the featurelist is passed to the dataprovider, where the proper id is assigned, but then the copy is deleted without the results being
mapped back to the python object.

| also couldn't find any commits which would have changed related code.

Can you tell me the last working version?

#2 - 2013-06-04 02:11 PM - Jiirgen Fischer
- Assignee changed from Jiirgen Fischer to Matthias Kuhn

#3 - 2013-06-04 10:13 PM - Denis Rouzaud

It used to work after this commit commit:7028827 (and probaby until before new API?)

#4 - 2013-06-05 01:09 AM - Denis Rouzaud

Re: addFeatures without knowing new feature's id, bug?

commit:6a8a9d44

#5 - 2013-06-05 02:32 AM - Denis Rouzaud
- Status changed from Open to Closed
http://lists.osgeo.org/pipermail/qgis-developer/2012-January/017839.html

forgot to call initAttributes after setFields.

s0 no bug at all.

#6 - 2013-06-05 04:51 AM - Matthias Kuhn

initAttributes is now issued automatically when calling setFields from python.
